/*
 * Copyright (c) 2021, GlassEditor. All rights reserved.
 *
 * This code is part of the GlassEditor API. You can see the terms 
 * of use at glasseditor.com/terms.
 * 
 * If you have any questions or problems with it please contact us
 * at glasseditor.com/contact.
 */
package com.glasseditor.api;

public abstract class Testing {
	public Checkpoint lastChild;
	public boolean restored;
	
	public static class Checkpoint {
		public Testing testing;
		public Checkpoint parent, lastChild;
		public boolean restored;
		public String name;
		public Object first;
		public Object[] values;
		public long time;
		public int index = -2, depth;
		
		public Checkpoint(Testing testing, Checkpoint parent, String name, Object first, Object[] values, long time) {
			this.testing = testing;
			this.parent = parent;
			this.name = name;
			this.first = first;
			this.values = values;
			this.time = time;
			this.depth = parent == null ? 0 : parent.depth + 1;
		}
		public Checkpoint checkpoint(){
			return checkpoint("");
		}
		public Checkpoint checkpoint(String name){
			return checkpoint(name, null);
		}
		public Checkpoint checkpoint(String name, Object value){
			return checkpoint(name, value, (Object[])null);
		}
		public Checkpoint checkpoint(String name, Object first, Object... values){
			if(lastChild != null && restored){
				Checkpoint l = lastChild;
				lastChild = null;
				return l;
			}
			Checkpoint c = new Checkpoint(testing, this, name, first, values, System.nanoTime());
			testing.checkpoint(c);
			return c;
		}
		public <T> T restore(int index, T start){
			restored = true;
			return lastChild == null ? start : (T)lastChild.values[index];
		}
	}
	public Testing(){
		
	}
	public Checkpoint checkpoint(){
		return checkpoint("");
	}
	public Checkpoint checkpoint(String name){
		return checkpoint(name, null);
	}
	public Checkpoint checkpoint(String name, Object value){
		return checkpoint(name, value, (Object[])null);
	}
	public Checkpoint checkpoint(String name, Object first, Object... values){
		if(lastChild != null && restored){
			Checkpoint l = lastChild;
			lastChild = null;
			return l;
		}
		Checkpoint c = new Checkpoint(this, null, name, first, values, System.nanoTime());
		checkpoint(c);
		return c;
	}
	public abstract void checkpoint(Checkpoint c);
	
	public <T> T restore(int index, T start){
		restored = true;
		return lastChild == null ? start : (T)lastChild.values[index];
	}
}
